/**
 * Creates an array with all falsey values removed. The values undefined,null,0,+0,-0,NaN,'',"",false are falsey.
 * <br>compact([1, 0, '', 8])//[1, 8]
 */
const compact = function (arr) {
    return arr.filter(v => v);
};
/**
 * 判断对象类型
 * <br>complexType(1)//'Number'
 * <br>complexType(new Date())//'Date'
 */
const complexType = function (o) {
    return Object.prototype.toString.call(o).slice(8, -1);
};
/**
 * 判断对象或数组非空
 * <br>isFilled({K: 1})//true
 * <br>isFilled({})//false
 * <br>isFilled([0,1,2])//3
 */
const isFilled = function (o) {
    if (Array.isArray(o))
        return o.length;
    for (let k in o) {
        return true;
    }
    return false;
};
/**
 * 判断变量未赋值<br>
 * 假值:undefined,null,0,+0,-0,NaN,'',"",false<br>
 * 空对象:{}<br>
 * 空数组:[]
 * <br>isFree({})//true
 * <br>isFree([])//true
 * <br>isFree(0)//true
 */
const isFree = function (o) {
    return !o || // 假值
        (typeof o === 'object' && (((complexType(o) === 'Array' || complexType(o) === 'Object') && !isFilled(o)) || // 空对象(或数组)
            (complexType(o) === 'String' && o.toString() === '') ||
            (complexType(o) === 'Number' && o.toString() === '0') ||
            (complexType(o) === 'Boolean' && o.toString() === 'false')));
};
if (typeof exports === 'object' &&
    typeof module !== 'undefined' &&
    module.exports) {
    module.exports = {
        complexType,
        isFilled,
        isFree,
        compact
    };
}
